import { prisma } from "@/module/_global";
import { funGetUserById } from "@/module/auth";
import { createLogUserMobile } from "@/module/user";
import _ from "lodash";
import { NextResponse } from "next/server";


// GET ALL POSITION
export async function GET(request: Request) {
    try {
        let grup
        const { searchParams } = new URL(request.url);
        const idGroup = searchParams.get("group");
        const active = searchParams.get('active');
        const name = searchParams.get('search')
        const userMobile = searchParams.get("user")

        if (userMobile == "null" || userMobile == undefined || userMobile == "") {
            return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
        }

        const user = await funGetUserById({ id: userMobile })

        if (idGroup == "null" || idGroup == "undefined" || idGroup == undefined || idGroup == "") {
            grup = user.idGroup
        } else {
            grup = idGroup
        }

        const cek = await prisma.group.count({
            where: {
                id: grup,
                isActive: true
            }
        })

        if (cek == 0) {
            return NextResponse.json({ success: false, message: "Gagal mendapatkan jabatan, data tidak ditemukan", }, { status: 200 });
        }

        const filter = await prisma.group.findUnique({
            where: {
                id: grup
            },
            select: {
                id: true,
                name: true
            }
        })

        const positions = await prisma.position.findMany({
            where: {
                idGroup: grup,
                isActive: active == 'false' ? false : true,
                name: {
                    contains: (name == undefined || name == null) ? "" : name,
                    mode: "insensitive"
                }
            },
            select: {
                id: true,
                name: true,
                isActive: true,
                idGroup: true,
                Group: {
                    select: {
                        name: true
                    }
                }
            },
        });

        const allData = positions.map((v: any) => ({
            ..._.omit(v, ["Group", "name"]),
            name: v.name,
            group: v.Group.name
        }))

        const dataFix = _.orderBy(allData, [data => data.name.toLowerCase()], ['asc']);

        return NextResponse.json({ success: true, message: "Berhasil mendapatkan jabatan", data: dataFix, filter }, { status: 200 });
    } catch (error) {
        console.error(error);
        return NextResponse.json({ success: false, message: "Gagal mendapatkan jabatan, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
    }
}



// CREATE POSITION
export async function POST(request: Request) {
    try {
        const { name, idGroup, user } = await request.json();

        if (user == "null" || user == undefined || user == "") {
            return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
        }

        const userMobile = await funGetUserById({ id: user })

        let groupFix = idGroup

        if (groupFix == null || groupFix == undefined || groupFix == "") {
            groupFix = userMobile.idGroup
        }


        const cek = await prisma.position.count({
            where: {
                name: name,
                idGroup: groupFix,
            },
        });
        if (cek == 0) {
            const positions = await prisma.position.create({
                data: {
                    name: name,
                    idGroup: groupFix,
                },
                select: {
                    id: true,
                    name: true,
                    idGroup: true
                },
            });

            // create log user
            const log = await createLogUserMobile({ act: 'CREATE', desc: 'User membuat data jabatan baru', table: 'position', data: positions.id, user })

            return NextResponse.json({ success: true, message: "Berhasil menambahkan jabatan" }, { status: 200 });
        } else {
            return NextResponse.json(
                { success: false, message: "Jabatan sudah ada" },
                { status: 200 }
            );
        }

    } catch (error) {
        console.error(error);
        return NextResponse.json({ success: false, message: "Gagal menambahkan jabatan, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
    }
}
